#!/usr/bin/perl

# httpd environment dump by Tom Laudeman.
# August 15 2008

use strict;
use CGI;
use CGI::Carp qw(fatalsToBrowser);

main:
{
    # print "Last-Modified: Wed, 21 Apr 2005 20:03:55 GMT\n";
    # must be DDD DD Mmm yyyy hh:mm:ss GMT
    # the comma seems optional.
    # print "Last-Modified: Wed 22 Apr 2005 00:36:55 GMT\n";

    print "Content-type: text/html\n\n";
    
    print "<HTML>\n";
    print "<HEAD><TITLE>httpd environment dump</TITLE></HEAD>\n";
    print "<BODY>httpd environment dump<br>\n";
    print "<HR>\n";
    
    my $time = `date`;
    my $where;
    if ($ENV{REMOTE_HOST})
    {
	$where = $ENV{'REMOTE_HOST'};
    }
    else
    {  
	$where = $ENV{REMOTE_ADDR};
    }  
    my $script   = $ENV{'SCRIPT_NAME'};
    my $all = `env`;  # Hmmmm. Doesn't seem to be used.
    
    print "Time = $time<BR>";
    print "Where = $where<BR>";
    print "Script = $script<BR>";

    print "<HR>\n";  
    
    # ReadParse is old think. If you don't have the Perl CGI module on your system,
    # make the if true to use the (outdated and less effective) sub ReadParse below
    # instead of the Perl CGI module.

    my %in;
    if (0)
    {
	%in = ReadParse();
    }
    else
    {
	my $qq = new CGI; # $q is the convention, but single letter vars are icky.
	%in = $qq->Vars();
	$in{__raw__} = $qq->Dump();
    }
    
    foreach my $key (sort(keys(%in)))
    {  
	    print "$key = $in{$key}<br>\n";
    }  
    
    print "<hr>\n";
    
    foreach my $key (sort(keys(%ENV)))
    {  
	print "$key = $ENV{$key}<BR>\n";
    }  
    
    # This is a section for things that you don't need frequently.
    # Allowing anyone to see this info might pose a security or privacy risk.
    # Change to if (0) to keep this from running.

    if (1) # print id info
    {  
	my $id = `id`;
	my $groups = `groups`;
	
	print "id $id<br>\n";
	print "groups $groups<br>\n";
    }  
    
    print "</BODY></HTML>";
}  


# This is taken from the ancient and venerable cgi-lib.pl.  It is an
# incomplete CGI implementation and is very much out of date.  Use the
# Perl CGI module instead. The CGI module is a standard part of Perl
# distributions. If you happen not to have it, look at
# http://search.cpan.org/

sub ReadParse
{
    my $in; # query (input) string
    my @in; # list of query key/value pairs
    my %in; # returned, hash of the query key/value pairs.
    
    my ($xx, $loc, $key, $val);
    
    #
    # Read in text
    # Note that ReadParse() could be called for a string, and not have an environment variable for 
    # REQUEST_METHOD
    # 

    if ($ENV{'REQUEST_METHOD'} eq "POST")
    {
	for ($xx = 0; $xx < $ENV{'CONTENT_LENGTH'}; $xx++)
	{
	    $in .= getc;
	}
    } 
    elsif ($ENV{'REQUEST_METHOD'} eq "GET")
    {
	$in = $ENV{'QUERY_STRING'};
    }
    
    
    # I've seen a rumor that the modern way to separate args in the query string is ; not &.
    # I tested NS 4.77 and IE 5.0 both of which use &

    @in = split('\&',$in);  
    for( $xx=0;  $xx <= $#in; $xx++)
    {
	# Convert plus's to spaces
	$in[$xx] =~ s/\+/ /g;
	
	# Convert %XX from hex numbers to alphanumeric
	$in[$xx] =~ s/%(..)/pack("c",hex($1))/ge;
	
	# Split into key and value.
	$loc = index($in[$xx],"=");
	$key = substr($in[$xx],0,$loc);
	$val = substr($in[$xx],$loc+1);
	if (defined($in{$key})) # \0 is the multiple separator
	{
	    $in{$key} .= '\0';
	}
	$in{$key} .= $val;
    }
    
    # include the original data for diagnostic purposes.
    $in{__raw__} = $in;
    return %in;

}
